package;

import flixel.FlxG;
import flixel.FlxSprite;
import flixel.group.FlxTypedGroup;
import flixel.text.FlxText;
import flixel.ui.FlxButton;
import flixel.util.FlxColor;
import flixel.util.FlxDestroyUtil;
using flixel.util.FlxSpriteUtil;

class HUD extends FlxTypedGroup<FlxSprite>
{
	private var _sprBack:FlxSprite;
	private var _ammoA:FlxText;
	private var _imgA:FlxSprite;
	private var _ammoB:FlxText;
	private var _imgB:FlxSprite;
	private var _tMage:FlxButton;
	private var _tArcher:FlxButton;
	private var _tFighter:FlxButton;
	private var _tCleric:FlxButton;
	private var _selfD:Int = 179;
	private var _forces:Int = 0;
	private var _endA:Int = 0;
	private var _endC:Int = 0;
	private var _endF:Int = 0;
	private var _endM:Int = 0;
	public var click(default, null):Click;
	public var auto(default, null):Auto;
	
	public function new() 
	{
		super();
		_sprBack = new FlxSprite(0, 455).makeGraphic(FlxG.width, 20, FlxColor.TRANSPARENT);
		_sprBack.drawRect(0, 0, FlxG.width, 2, FlxColor.WHITE);
		
		_tMage = new FlxButton((FlxG.width / 5), 458, "Mago", actMago);
		_tArcher = new FlxButton((FlxG.width / 5)*2, 458, "Guerrero", actFight);
		_tFighter = new FlxButton((FlxG.width / 5)*3, 458, "Pícaro", actArcher);
		_tCleric = new FlxButton((FlxG.width / 5)*4, 458, "Clérigo", actCleric);
		
		_ammoA = new FlxText(30, (FlxG.height / 10)*1, 0, "Nadie Seleccionado", 18);
		_ammoA.setBorderStyle(FlxText.BORDER_SHADOW, FlxColor.GRAY, 1, 1);
		_ammoB = new FlxText((FlxG.width / 6)*5, (FlxG.width / 8), 0, "00", 20);
		_ammoB.setBorderStyle(FlxText.BORDER_SHADOW, FlxColor.RED, 1, 1);
		
		add(_sprBack);
		add(_ammoA);
		add(_ammoB);
		add(_tMage);
		add(_tArcher);
		add(_tFighter);
		add(_tCleric);
	}
	
	public function updateHUD(Ammo:Int=0)
	{
		_ammoB.text = Std.string(Ammo);
		imminent();
	}
	
	public function updateKnight(Ammo:Int=0)
	{
		knight();
		imminent();
	}
	
	public function updateMagius(Ammo:Int=0)
	{
		magius();
		imminent();
	}
	
	public function updateRogue(Ammo:Int=0)
	{
		rogue();
		imminent();
	}
	
	public function updateHoly(Ammo:Int=0)
	{
		holy();
		imminent();
	}
	
	public function ahora():Void
	{
		auto = NONE;
		_ammoA.text = Std.string("¿Quién?");
		
	}
	
	override public function destroy():Void
	{
		_sprBack = FlxDestroyUtil.destroy(_sprBack);
		_ammoA = FlxDestroyUtil.destroy(_ammoA);
		_tMage = FlxDestroyUtil.destroy(_tMage);
		_tCleric = FlxDestroyUtil.destroy(_tCleric);
		_tFighter = FlxDestroyUtil.destroy(_tFighter);
		_tArcher = FlxDestroyUtil.destroy(_tArcher);
	}
	
	public function actMago():Void
	{
		click = RELOAD;
		auto = BLAST;
		_ammoA.text = Std.string("Mago");
		magius();
	}
	
	public function actArcher():Void
	{
		click = RELOAD;
		auto = RANGE;
		_ammoA.text = Std.string("Pícaro");
		rogue();
	}
	
	public function actFight():Void
	{
		click = RELOAD;
		auto = BRAWL;
		_ammoA.text = Std.string("Guerrero");
		knight();
	
	}
	
	public function actCleric():Void
	{
		click = RELOAD;
		auto = HEAL;
		_ammoA.text = Std.string("Clérigo");
		holy();
	
	}
	
	public function gunning():Void
	{
		if (_selfD <= 0)
		{
			click = KILLED;
			thisis();
		}
	}
	
	public function readyGun():Void
	{
		click = NONE;
	}
	
	public function magius():Void
	{
		_endM ++;
		_selfD --;
		
	}
	
	public function knight():Void
	{
		_endF ++;
		_selfD --;
		
	}
	
	public function rogue():Void
	{
		_endA ++;
		_selfD --;
		
	}
	
	public function holy():Void
	{
		_endC ++;
		_selfD --;
		
	}
	
	public function imminent():Void
	{
		_selfD --;
	}
	
	public function timeless():Void
	{
		if(_selfD >=80)
		_selfD = (_selfD + 60);
	}
	
	private function results():Void
	{
		if (_endA >= _endM)
		{
			if (_endA >= _endF)
			{
				if (_endA > _endC)
				{
					_selfD = 0;
				}
				else
					_selfD = 1;
				
			}
			else
			{
				if (_endF > _endC)
				{
					_selfD = 2;
				}
				else
					_selfD = 1;
				}
		}
		else
		{
			if (_endM >= _endF)
			{
				if (_endM > _endC)
				{
					_selfD = 3;
				}
				else
					_selfD = 1;
			}
			else
			{
				if (_endF > _endC)
				{
					_selfD = 2;
				}
				else
					_selfD = 1;
			}
		}
		
	}
	
	public function thisis():Void
	{
		if (click == KILLED)
		{
			results();
			FlxG.switchState(new OverState(_selfD));
		}
	}
}

enum Auto {
	NONE;
	HEAL;
	BRAWL;
	BLAST;
	RANGE;
}

enum Click {
	NONE;
	RELOAD;
	GUN;
	KILLED;
}