package;
import flixel.FlxG;
import flixel.FlxObject;
import flixel.FlxSprite;
import flixel.util.FlxAngle;
import flixel.util.FlxColor;
import flixel.util.FlxPoint;
import flixel.util.FlxRandom;
import flixel.util.FlxVelocity;


class HeroM extends FlxSprite
{
	public var speed:Float = 300;
	public var boost:Int = 1;
	public var _dif:Int = 1;
	private var _idleTmr:Float;
	private var _aim:FlxPoint;
	private var _moveDir:Float;
	private var _f:Int = 0;
	public var fireB:Bool = false;
	public var statusm(default, null):Statusm;
		
	public function new(X:Float=0, Y:Float=0) 
	{
		super(X, Y);
		loadGraphic(AssetPaths.mago__png, true, 40, 40);
		animation.add("d", [6, 7, 12, 6], 4, false);
		animation.add("l", [4, 5, 11, 1], 4, false);
		animation.add("r", [3, 2, 10, 0], 4, false);
		animation.add("u", [8, 9, 13, 8], 4, false);
		animation.add("atu", [13, 9], 2, false);
		animation.add("atd", [12, 0], 2, false);
		animation.add("atl", [11, 1], 2, false);
		animation.add("atr", [10,0], 2, false);
		
		width = 15;
		height = 28;
		offset.x = 12;
		offset.y = 12;
		drag.x = drag.y = 125;
		_idleTmr = 1;
		elasticity = .1;
	
	}
	
	override public function draw():Void 
    {
        if ((velocity.x != 0 || velocity.y != 0 ) && touching == FlxObject.NONE)
        {
            harder();	
			if (Math.abs(velocity.x) > Math.abs(velocity.y))
            {
                if (velocity.x < 0)
                    facing = FlxObject.LEFT;
                else
                    facing = FlxObject.RIGHT;
            }
            else
            {
                if (velocity.y < 0)
                    facing = FlxObject.UP;
                else
                    facing = FlxObject.DOWN;
            }

            switch(facing)
            {
                case FlxObject.LEFT:
					animation.play("l");

				case FlxObject.RIGHT:
                    animation.play("r");

                case FlxObject.UP:
                    animation.play("u");

                case FlxObject.DOWN:
                    animation.play("d");
            }
        }
        super.draw();
    }
	
	override public function update():Void
	{
		super.update();
		movement(_dif);
	}
	
	public function harder():Void
	{
		_f ++;
		if (_f>8)
		{
			_f = 0;
			fireB = true;
		
		}
	}
	
	public function statOrder():Void
	{
		statusm = ORDER;
	}
	
	public function resting():Void
	{
		fireB = false;	
		_f = 0;
	}
	
	public function answer(Destin:FlxPoint):Void
	{
		if (statusm == ORDER)
		{
		_aim = new FlxPoint(Destin.x,Destin.y);
		FlxVelocity.moveTowardsPoint(this, _aim, speed, 0);
		statusm = COOL;
		}
		if (statusm == COOL)
		{
			//shooting();
		}
	}
	
	public function recast():Void
	{
		fireB = true;
	}
		
	public function movement(D:Int):Void
	{
		if (statusm == ORDER)
			return;
		
		if (_idleTmr >= 0)
		{
			if (FlxRandom.chanceRoll(10))
			{
				_moveDir = -1;
				velocity.x = velocity.y = 0;
			}
			else
			{
				boost = D;
				_moveDir = FlxRandom.intRanged(0, 8) * 45;
				FlxAngle.rotatePoint(speed*boost, 0, 0, 0, _moveDir, velocity);
			}
		_idleTmr --;
		}
	
	}
}

enum Statusm {
	NONE;
	ORDER;
	COOL;
}