package;

import flixel.addons.editors.ogmo.FlxOgmoLoader;
import flixel.FlxG;
import flixel.FlxObject;
import flixel.FlxSprite;
import flixel.FlxState;
import flixel.group.FlxTypedGroup;
import flixel.text.FlxText;
import flixel.tile.FlxTilemap;
import flixel.tweens.FlxTween;
import flixel.ui.FlxButton;
import flixel.util.FlxDestroyUtil;
import flixel.util.FlxMath;
import flixel.util.FlxPoint;
import flixel.util.FlxRandom;
import flixel.util.FlxVelocity;
using flixel.util.FlxSpriteUtil;


class PlayState extends FlxState
{
	private var _target:FlxTypedGroup<Victims>;
	private var _brawl:HeroF;
	private var _range:HeroA;
	private var _heal:HeroC;
	private var _blast:HeroM;
	private var _map:FlxOgmoLoader;
	private var _mWalls:FlxTilemap;
	private var _hud:HUD;
	private var _bullets:Int = 6;
	private var _a:Int = 0;
	private var _forces:Int = 0;
	private var _win:Int = -100;
	private var _angle:FlxPoint;
	private var _ending:Bool;
	private var _won:Bool;
	private var _alert:FlxText;
	private var _atRange:FlxTypedGroup<Dagger>;
	private var _atFire:FlxTypedGroup<Xplosion>;
	private var _auHeal:FlxTypedGroup<Aura>;
	
	override public function create():Void
	{
		_map = new FlxOgmoLoader(AssetPaths.prueba__oel);
		_mWalls = _map.loadTilemap(AssetPaths.tiles__png, 20, 20, "walls");
		_mWalls.setTileProperties(2, FlxObject.NONE);
		_mWalls.setTileProperties(1, FlxObject.ANY);
		add(_mWalls);
		_alert = new FlxText((FlxG.width / 9)*4, (FlxG.height / 9)*4, 0, "Y nosotros que hacemos?", 22, false);
		_alert.visible = false;
		_brawl = new HeroF();
		_range = new HeroA();
		_heal = new HeroC();
		_blast = new HeroM();
		_map.loadEntities(placeEntities, "entities");
		_atRange = new FlxTypedGroup<Dagger>();
		_atFire = new FlxTypedGroup<Xplosion>();
		_auHeal = new FlxTypedGroup<Aura>();
		_target = new FlxTypedGroup<Victims>();
		_target.add(new Victims(40, 40));
		add(_heal);
		add(_range);
		add(_blast);
		add(_brawl);
		add(_target);
		add(_alert);
		add(_atRange);
		add(_auHeal);
		add(_atFire);
		_angle = new FlxPoint();
		_hud = new HUD();
		add(_hud);
		super.create();
	}
	
	override public function destroy():Void
	{
		super.destroy();
		_target = FlxDestroyUtil.destroy(_target);
		_hud = FlxDestroyUtil.destroy(_hud);
		_heal = FlxDestroyUtil.destroy(_heal);
		_range = FlxDestroyUtil.destroy(_range);
		_blast = FlxDestroyUtil.destroy(_blast);
		_brawl = FlxDestroyUtil.destroy(_brawl);
		_alert = FlxDestroyUtil.destroy(_alert);
		_atFire = FlxDestroyUtil.destroy(_atFire);
		_atRange = FlxDestroyUtil.destroy(_atRange);
		_auHeal = FlxDestroyUtil.destroy(_auHeal);
		
	}

	override public function update():Void
	{
		super.update();
		if (_ending)
		{
			return;
		}
		_hud.gunning();
		FlxG.collide(_target, _mWalls);
		FlxG.collide(_heal, _mWalls);
		FlxG.collide(_range, _mWalls);
		FlxG.collide(_brawl, _mWalls);
		FlxG.collide(_blast, _mWalls);
		FlxG.overlap(_auHeal, _target, auraInTarget);
		FlxG.overlap(_brawl, _target, fighterInTarget);
		FlxG.overlap(_blast, _target, mageInTarget);
		FlxG.overlap(_brawl, _auHeal, fighterInAura);
		FlxG.overlap(_blast, _auHeal, mageInAura);
		FlxG.overlap(_range, _auHeal, rangerInAura);
		FlxG.overlap(_atRange, _target, daggerInTarget);
		FlxG.collide(_atFire, _target, fireInTarget);
		FlxG.collide(_atRange, _mWalls, daggerInWall);
		FlxG.collide(_atFire, _mWalls, fireInWall);
		if (_hud.click == RELOAD)
		{
			_bullets = 9;
			_hud.readyGun();
			_alert.visible = false;
			return;
		}
		automatons();
		progression();
		shoot();
		tide();
		if (_range.dagger == true)
		{
			_atRange.add(new Dagger(_range.x, _range.y));
			_range.resting();
		}
		if (_heal.aura == true)
		{
			_auHeal.add(new Aura(_heal.x-30, _heal.y-15));
			_heal.resting();
		}
		_auHeal.forEachAlive(checkAuraVision);

		if (_blast.fireB == true)
		{
			_angle = FlxVelocity.velocityFromFacing(_blast, _blast.speed*4);
			_atFire.add(new Xplosion(_blast.x, _blast.y, _angle));
			_blast.resting();
			
		}
		//	alert();
		
	}	
	
	private function tide():Void
	{
		if (_win >= 180)
		{
			_won = true;
			_ending = true;
			FlxG.switchState(new MenuState());
		}
		if (_win >= 60)
		{
			_hud.timeless();
		}
		
	}
	
	private function automatons():Void
	{
		if (_hud.auto == BLAST)
			_blast.statOrder();
		else if (_hud.auto == BRAWL)
			_brawl.statOrder();
		else if (_hud.auto == HEAL)
			_heal.statOrder();
		else if (_hud.auto == RANGE)
			_range.statOrder();
	}
	
	private function placeEntities(entityName:String, entityData:Xml):Void
	{
		var x:Int = Std.parseInt(entityData.get("x"));
		var y:Int = Std.parseInt(entityData.get("y"));
		if (entityName == "blast")
		{
				_blast.x = x;
				_blast.y = y;
		}
		else if (entityName == "brawl")
		{
				_brawl.x = x;
				_brawl.y = y;
		}
		else if (entityName == "range")
		{
			_range.x = x;
			_range.y = y;
		}
		else
		{
			_heal.x = x;
			_heal.y = y;
		}
		
	}
	
	public function alert():Void
	{
		FlxTween.tween(_alert, { x:_alert.x + 40 }, .5, { complete: function(_) {
			FlxTween.tween(_alert, { x:_alert.x - 40 }, .5);
		}} );
	}
	
	public function progression():Void
	{
		if (FlxRandom.chanceRoll(5))
			{
			_target.add(new Victims((FlxRandom.intRanged(1, 5) * 100), (FlxRandom.intRanged(1, 3) * 100)));
			_forces ++;
			_hud.updateHUD(_forces);
			}
			
		if (_a == 35)
		{
			if (FlxRandom.chanceRoll(20))
			{
			_target.add(new Victims((FlxRandom.intRanged(1, 5) * 100), (FlxRandom.intRanged(1, 3) * 100)));
			_forces ++;
			_hud.updateHUD(_forces);
			}
			_a = 0;
			
		}
		_a ++;
		
	}
	
	public function shoot()
	{
		if (FlxG.mouse.justReleased == true)
		{
			_angle = (FlxG.mouse.getWorldPosition());
			if (_bullets <= 0)
			{
				_bullets = 9;
				_a = 35;
				_hud.ahora();
				_alert.visible = true;
				
			}
			_bullets --;
			
			if (_hud.auto == HEAL)
			{
				
				_heal.answer(_angle);
				_hud.updateHoly();
			}	
		
			else if (_hud.auto == BLAST)
			{
				_blast.answer(_angle);
				_hud.updateMagius();
			}
			
			else if (_hud.auto == BRAWL)
			{
				_brawl.answer(_angle);
				_hud.updateKnight();
			}
			
			else if (_hud.auto == RANGE)
			{
				_range.answer(_angle);
				_hud.updateRogue();
			}
		}
	}
	
	public function daggerInWall(B:Dagger, W:FlxTilemap):Void
	{
		if (B.alive && B.exists && W.alive && W.exists)
		{
			B.destroy();
		}
	}
	
	public function auraInTarget(B:Aura, W:Victims):Void
	{
		if (B.alive && B.exists && W.alive && W.exists)
		{
			W.flicker();
		}
	}
	
	public function fireInWall(B:Xplosion, W:FlxTilemap):Void
	{
		if (B.alive && B.exists && W.alive && W.exists)
		{
			B.destroy();
		}
	}
		
	public function daggerInTarget(B:Dagger, T:Victims):Void
	{
		if (B.alive && B.exists && T.alive && T.exists)
		{
			T.destroy();
			_forces --;
			_win ++;
		}
	}
	
	public function fireInTarget(B:Xplosion, T:Victims):Void
	{
		if (B.alive && B.exists && T.alive && T.exists)
		{
			B.remain();
			T.demise();
			_forces --;
			_win ++;
		}
	}
	
	public function fighterInTarget(B:HeroF, T:Victims):Void
	{
		if (B.alive && B.exists && T.alive && T.exists)
		{
			
			T.demise();
			_forces --;
			_win ++;
		}
	}
	
	public function mageInTarget(B:HeroM, T:Victims):Void
	{
		if (B.alive && B.exists && T.alive && T.exists)
		{
			
			B.flicker();
		}
	}
	
	public function fighterInAura(B:HeroF,T:Aura):Void
	{
		if (B.alive && B.exists && T.alive && T.exists)
		{
			B.recast();
		}
	}
	
	public function mageInAura(B:HeroM,T:Aura):Void
	{
		if (B.alive && B.exists && T.alive && T.exists)
		{
			B.stopFlickering();
			B.recast();
		}
	}	
	
	public function rangerInAura(B:HeroA,T:Aura):Void
	{
		if (B.alive && B.exists && T.alive && T.exists)
		{
			
		}
	}
		
	
	private function checkAuraVision(a:Aura):Void
	{
		if (_mWalls.ray(a.getMidpoint(), _heal.getMidpoint()))
		{
		a.seesPlayer = true;
		a.getCleric(_heal.getMidpoint());
		}
		else
		a.seesPlayer = false;
	}
	
}