package;
import flixel.FlxG;
import flixel.FlxObject;
import flixel.FlxSprite;
import flixel.tweens.FlxTween;
import flixel.util.FlxAngle;
import flixel.util.FlxColor;
import flixel.util.FlxRandom;
using flixel.util.FlxSpriteUtil;
	

class Victims extends FlxSprite
{
	public var speed:Float = 300;
	public var boost:Int = 1;
	public var _dif:Int = 1;
	private var _idleTmr:Float;
	private var _moveDir:Float;
	private var _b:Int = 0;
	public var statusv(default, null):Statusv;
	
	public function new(X:Float=0, Y:Float=0) 
	{
		super(X, Y);
		loadGraphic(AssetPaths.enemigo__png, true, 40, 40);
		animation.add("d", [6, 7, 12, 6], 6, false);
		animation.add("l", [4, 5, 11, 1], 6, false);
		animation.add("r", [3, 2, 10, 3], 6, false);
		animation.add("u", [8, 9, 13, 8], 6, false);
		animation.add("atu", [13, 9], 2, false);
		animation.add("atd", [12, 0], 2, false);
		animation.add("atl", [11, 1], 2, false);
		animation.add("atr", [10, 0], 2, false);
		animation.add("death", [14, 15, 14,15, 14], 11, false);
		
		width = 15;
		height = 28;
		offset.x = 12;
		offset.y = 12;
		drag.x = drag.y = 50;
		elasticity = .7;
		_idleTmr = 0;
		
	}
	
	override public function draw():Void 
    {
        if ((velocity.x != 0 || velocity.y != 0 ) && touching == FlxObject.NONE)
        {
            if (Math.abs(velocity.x) > Math.abs(velocity.y))
            {
                if (velocity.x < 0)
                    facing = FlxObject.LEFT;
                else
                    facing = FlxObject.RIGHT;
            }
            else
            {
                if (velocity.y < 0)
                    facing = FlxObject.UP;
                else
                    facing = FlxObject.DOWN;
            }

            switch(facing)
            {
                case FlxObject.LEFT:
					animation.play("l");

				case FlxObject.RIGHT:
                    animation.play("r");

                case FlxObject.UP:
                    animation.play("u");

                case FlxObject.DOWN:
                    animation.play("d");
            }
        }
        if (statusv == DYING)
		{
			animation.play("death");
		}
		super.draw();
    }
	
	override public function update():Void
	{
		super.update();
				
		movement(_dif);
		harder();
		if (statusv == DYING)
		{
			if (boost > 0)
			{
				boost --;
			}
			else
				ended();
		}
	}
	
	public function harder():Void
	{
		_b ++;
		if (_b == 350)
		{
			_dif ++;
		}
	}
	
	public function demise():Void
	{
		animation.play("death");
		FlxTween.tween(this, { x:this.x + 40 }, .3, { complete: function(_) {
			FlxTween.tween(this, { x:this.x - 40 }, .3);
		}} );
		animation.play("death");
		statusv = DYING;
	}
	
	private function ended():Void
	{
		this.destroy();
	}
		
	public function movement(D:Int):Void
	{
		if (isFlickering())
		{
			return;
		}
		
		if (_idleTmr <= 0)
		{
			if (FlxRandom.chanceRoll(50))
				{
					_moveDir = FlxRandom.intRanged(1, 3) * 90;
					FlxAngle.rotatePoint(speed*boost, 0, 0, 0, _moveDir, velocity);
				}
			else
			{
				if (FlxRandom.chanceRoll(5))
				{
					_moveDir = -1;
					velocity.x = velocity.y = 0;
				}
				boost = D;
				_moveDir = FlxRandom.intRanged(0, 1) * 180;
				FlxAngle.rotatePoint(speed*boost, 0, 0, 0, _moveDir, velocity);
			}
			_idleTmr = FlxRandom.intRanged(15, 30);
		}
		else
		{
			_idleTmr --;
		}
	}
	
}

enum Statusv {
	NONE;
	DYING;
	COOL;
}